<?php

/**
 * UserIdentity represents the data needed to identity a user.
 * It contains the authentication method that checks if the provided
 * data can identity the user.
 */
class UserIdentity extends CUserIdentity {

	public $source;

	public function __construct($username) {
		$this->source = $username;
	}

	/**
	 * Authenticates a user.
	 * The example implementation makes sure if the username and password
	 * are both 'demo'.
	 * In practical applications, this should be changed to authenticate
	 * against some persistent user identity storage (e.g. database).
	 * @return boolean whether authentication succeeds.
	 */
	public function authenticate() {
		$record = new User();
		$record->source = $this->source;

		if ($record->validate()) {
			$this->errorCode = self::ERROR_NONE;
		} else {
			$this->errorCode = self::ERROR_USERNAME_INVALID;
		}

		return !$this->errorCode;
	}

	public function getId() {
		return hash('md5', Yii::app()->params['realm'] . '::'
			 . Yii::app()->request->userAgent . '::'
			 . Yii::app()->request->userHostAddress);
	}

	public function getName() {
		return $this->source;
	}

}
